"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.simpleNewInputPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var item = _propTypes.default.shape({
  value: _propTypes.default.string.isRequired,
  label: _propTypes.default.string.isRequired
});

var rawValue = _propTypes.default.oneOfType([_propTypes.default.string.isRequired, _propTypes.default.bool.isRequired, _propTypes.default.number.isRequired]);

var rawItem = _propTypes.default.shape({
  value: rawValue.isRequired,
  label: rawValue.isRequired
});

var AppPropTypes = {
  item: item,
  itemList: _propTypes.default.arrayOf(item),
  element: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.func, _propTypes.default.shape({
    current: _propTypes.default.element
  })]),
  rawValue: rawValue,
  rawItem: rawItem,
  rawItemList: _propTypes.default.arrayOf(rawItem),
  styles: {
    styles_fontSize: _propTypes.default.string.isRequired,
    styles_borderRadius: _propTypes.default.string.isRequired,
    styles_paddingTop: _propTypes.default.string.isRequired,
    styles_paddingBottom: _propTypes.default.string.isRequired,
    styles_paddingLeft: _propTypes.default.string.isRequired,
    styles_paddingRight: _propTypes.default.string.isRequired,
    styles_selection_paddingTop: _propTypes.default.string.isRequired,
    styles_selection_paddingBottom: _propTypes.default.string.isRequired,
    styles_selection_paddingLeft: _propTypes.default.string.isRequired,
    styles_selection_paddingRight: _propTypes.default.string.isRequired,
    styles_selection_margin: _propTypes.default.string.isRequired,
    styles_option_paddingTop: _propTypes.default.string.isRequired,
    styles_option_paddingBottom: _propTypes.default.string.isRequired,
    styles_option_paddingLeft: _propTypes.default.string.isRequired,
    styles_option_paddingRight: _propTypes.default.string.isRequired,
    styles_checkRadio_borderWidth: _propTypes.default.string.isRequired,
    styles_checkRadio_marginBetween: _propTypes.default.string.isRequired,
    styles_checkRadio_labelMargin: _propTypes.default.string.isRequired,
    styles_checkRadio_paddingTop: _propTypes.default.string.isRequired,
    styles_checkRadio_paddingBottom: _propTypes.default.string.isRequired,
    styles_checkRadio_paddingLeft: _propTypes.default.string.isRequired,
    styles_checkRadio_paddingRight: _propTypes.default.string.isRequired,
    styles_search_width: _propTypes.default.string.isRequired,
    styles_icon_width: _propTypes.default.string.isRequired,
    styles_colors_primary: _propTypes.default.string.isRequired,
    styles_colors_secondary: _propTypes.default.string.isRequired,
    styles_colors_highlight: _propTypes.default.string.isRequired,
    styles_colors_warning: _propTypes.default.string.isRequired,
    styles_colors_warningBold: _propTypes.default.string.isRequired,
    styles_colors_disabled: _propTypes.default.string.isRequired,
    styles_colors_background: _propTypes.default.string.isRequired
  }
};

var simpleNewInputPropTypes = _objectSpread({
  onChange: _propTypes.default.func.isRequired,
  onBlur: _propTypes.default.func.isRequired,
  onFocus: _propTypes.default.func.isRequired,
  name: _propTypes.default.string.isRequired,
  selection: _propTypes.default.oneOfType([AppPropTypes.rawValue.isRequired, _propTypes.default.arrayOf(AppPropTypes.rawValue).isRequired, AppPropTypes.itemList.isRequired]).isRequired,
  options: _propTypes.default.oneOfType([AppPropTypes.rawItemList.isRequired, AppPropTypes.itemList.isRequired]).isRequired,
  placeholder: _propTypes.default.string.isRequired,
  multiple: _propTypes.default.bool.isRequired,
  disabled: _propTypes.default.bool.isRequired,
  creatable: _propTypes.default.bool.isRequired,
  removable: _propTypes.default.bool.isRequired,
  appendToBody: _propTypes.default.bool.isRequired,
  rightToLeft: _propTypes.default.bool.isRequired,
  filterOptions: _propTypes.default.func.isRequired,
  massageDataIn: _propTypes.default.func.isRequired,
  massageDataOut: _propTypes.default.func.isRequired,
  optionKeys: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,
  checkRadioMaxCount: _propTypes.default.number.isRequired,
  text_placeholder: _propTypes.default.string.isRequired,
  text_noOptions: _propTypes.default.string.isRequired,
  text_create: _propTypes.default.string.isRequired,
  component_HtmlFieldData: AppPropTypes.element.isRequired,
  component_Wrapper: AppPropTypes.element.isRequired,
  component_Selection: AppPropTypes.element.isRequired,
  component_SelectionList: AppPropTypes.element.isRequired,
  component_OptionList: AppPropTypes.element.isRequired,
  component_Option: AppPropTypes.element.isRequired,
  component_Search: AppPropTypes.element.isRequired,
  component_SelectionWrapper: AppPropTypes.element.isRequired,
  component_OptionWrapper: AppPropTypes.element.isRequired,
  component_AppendToBodyOptionsWrapper: AppPropTypes.element.isRequired,
  component_StyledAppendToBodyOptionsWrapper: AppPropTypes.element.isRequired
}, AppPropTypes.styles);

exports.simpleNewInputPropTypes = simpleNewInputPropTypes;
var _default = AppPropTypes;
exports.default = _default;